TestRadyaLab/Models/ContextModel.cs
namespace TestRadyaLab.Models
{
    using System;
    using System.Data.Entity;
    using System.Linq;
    using TestRadyaLab;
    public class ContextModel : DbContext
    {
        // Your context has been configured to use a 'ContextModel' connection string from your application's 
        // configuration file (App.config or Web.config). By default, this connection string targets the 
        // 'TestRadyaLab.Models.ContextModel' database on your LocalDb instance. 
        // 
        // If you wish to target a different database and/or database provider, modify the 'ContextModel' 
        // connection string in the application configuration file.
        public ContextModel()
            : base("name=DefaultConnection")
        {
        }
        public DbSet<Rumah> Rumah { get; set; }
        // Add a DbSet for each entity type that you want to include in your model. For more information 
        // on configuring and using a Code First model, see http://go.microsoft.com/fwlink/?LinkId=390109.

        // public virtual DbSet<MyEntity> MyEntities { get; set; }
    }

    //public class MyEntity
    //{
    //    public int Id { get; set; }
    //    public string Name { get; set; }
    //}
}

TestRadyaLab/Models/Rumah.cs
using System;
using System.Web;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace TestRadyaLab.Models
{
    public class Rumah
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int Id { get; set; }
        [Required(ErrorMessage="Tipe harus diisi")]
        public string Tipe { get; set; }
        [Required(ErrorMessage="Alamat harus diisi")]
        public string Alamat { get; set; }
        [Required(ErrorMessage="Latitude harus diisi")]
        public string Lat { get; set; }
        [Required(ErrorMessage="Longitude harus diisi")]
        public string Long { get; set; }
        public string Kecamtan { get; set; }
        public string Kota { get; set; }
        public string Provinsi { get; set; }
    }
}

TestRadyaLab/Controllers/DataRumahController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using TestRadyaLab.Models;

namespace TestRadyaLab.Controllers
{
    public class DataRumahController : Controller
    {
        ContextModel context = new ContextModel();
        //
        // GET: /DataRumah/
        
        public ActionResult Index()
        {
            ViewBag.listData = context.Rumah.ToList();
            return View();
        }

        public ActionResult Add()
        {
            Rumah model = new Rumah();
            ViewBag.Title = "Tambah Data Rumah";
            return View("Form", model);
        }

        [HttpPost]
        public ActionResult Add(Rumah model)
        {
            context.Rumah.Add(model);
            context.SaveChanges();

            return RedirectToAction("Index");
        }

        public ActionResult Edit(int id)
        {
            Rumah model = context.Rumah.Find(id);
            ViewBag.Title = "Edit " + model.Alamat;
            return View("Form", model);
        }

        [HttpPost]
        public ActionResult Edit(Rumah model)
        {
            context.Rumah.Attach(model);

            var entry = context.Entry(model);
            
            entry.State = System.Data.Entity.EntityState.Modified;

            context.SaveChanges();

            return RedirectToAction("Index");
        }

        public ActionResult Delete(int id)
        {
            Rumah dbitem = context.Rumah.Find(id);

            context.Rumah.Remove(dbitem);

            context.SaveChanges();

            return RedirectToAction("Index");
        }
    }
}

TestRadyaLab/Views/DataRumah/Form.cshtml
@using TestRadyaLab.Models;

@model TestRadyaLab.Models.Rumah
@{
    Layout = "~/Views/Shared/_Layout.cshtml";
    string currentAction = (string)ViewContext.RouteData.Values["action"];
    List<SelectListItem> listItems = new List<SelectListItem>();
    listItems.Add(new SelectListItem
    {
        Text = "36",
        Value = "36"
    });
    listItems.Add(new SelectListItem
    {
        Text = "45",
        Value = "45"
    });
    listItems.Add(new SelectListItem
    {
        Text = "72",
        Value = "72"
    });
}
<script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false&key=AIzaSyBfPWT55ybzPawdPYh58Y85LICkYHQe27U&libraries=places&callback=initMap" async defer></script>
<h2>@ViewBag.Title</h2>
@using (@Html.BeginForm(currentAction, "DataRumah", FormMethod.Post, new { @class = "form-horizontal" }))
{
    @Html.HiddenFor(model => model.Id)
    @Html.HiddenFor(model => model.Kecamtan)
    @Html.HiddenFor(model => model.Kota)
    @Html.HiddenFor(model => model.Provinsi)
    <div class="row">
        <div class="col-md-6">
            <div class="form-group">
                <label class="control-label col-md-2">Tipe</label>
                <div class="col-md-10">
                    @Html.DropDownListFor(model => model.Tipe, listItems, new { @class = "form-control" })
                </div>
            </div>
            <div class="form-group">
                <label class="control-label col-md-2">Alamat</label>
                <div class="col-md-10">
                    @Html.TextBoxFor(model => model.Alamat, new { @class = "form-control" })
                </div>
            </div>
            <div class="form-group">
                <label class="control-label col-md-2">Latitude</label>
                <div class="col-md-10">
                    @Html.TextBoxFor(model => model.Lat, new { @class = "form-control", @readonly = "readonly" })
                </div>
            </div>
            <div class="form-group">
                <label class="control-label col-md-2">Longitude</label>
                <div class="col-md-10">
                    @Html.TextBoxFor(model => model.Long, new { @class = "form-control", @readonly = "readonly" })
                </div>
            </div>
            <div class="form-group">
                <div class="col-md-offset-2 col-md-10">
                    <button type="submit" class="btn btn-success">Submit</button>
                    <a href="@Url.Action("index")" class="btn btn-link">Cancel</a>
                </div>
            </div>
        </div>
        <div class="col-md-6">
            <div id="map" style="width: 100%; height: 300px; margin-bottom: 10px"></div>
        </div>
    </div>
}

@section scripts{
    <script type="text/javascript">
    function initMap() {
        var map = new google.maps.Map(document.getElementById('map'), {
            zoom: 10,
            @if ((Model.Lat != null && Model.Lat != "") && (Model.Long != null && Model.Long != ""))
                {
                    <text>
            center: new google.maps.LatLng(@Model.Lat, @Model.Long),
            </text>
                }
                else
                {
                <text>
            center: new google.maps.LatLng(-6.9170227, 107.63337000000001),
            </text>
            }
            mapTypeId: google.maps.MapTypeId.ROADMAP
        });
        var infowindow = new google.maps.InfoWindow();
        var marker = new google.maps.Marker({
            map: map,
            @if ((Model.Lat != null && Model.Lat != "") && (Model.Long != null && Model.Long != ""))
                {
                    <text>
            position: new google.maps.LatLng(@Model.Lat, @Model.Long),
            </text>
                }
            anchorPoint: new google.maps.Point(0, -29)
        });
        var autocomplete = new google.maps.places.Autocomplete((document.getElementById('Alamat')), { types: ['geocode'] });
        autocomplete.addListener('place_changed', function () {
            var place = autocomplete.getPlace();
            //ambil lat, long
            $('#Lat').val(place.geometry.location.lat());
            $('#Long').val(place.geometry.location.lng());
            if(place.address_components.length > 0)
            {
                //provinsi
                console.log(place.address_components[place.address_components.length - 2])
                if(place.address_components[place.address_components.length - 2] != null)
                    $('#Provinsi').val(place.address_components[place.address_components.length - 2].long_name);
                //kota
                console.log(place.address_components[place.address_components.length - 3])
                if(place.address_components[place.address_components.length - 3] != null)
                    $('#Kota').val(place.address_components[place.address_components.length - 3].long_name);
                //kecamtan
                console.log(place.address_components[place.address_components.length - 4])
                if(place.address_components[place.address_components.length - 4] != null)
                    $('#Kecamtan').val(place.address_components[place.address_components.length - 4].long_name);
            }
            console.log(place)
            if (place.geometry) {
                //fokus map
                if (place.geometry.viewport) {
                    map.fitBounds(place.geometry.viewport);
                } else {
                    map.setCenter(place.geometry.location);
                }
                //marker.setIcon(({
                //    url: place.icon,
                //    size: new google.maps.Size(71, 71),
                //    origin: new google.maps.Point(0, 0),
                //    anchor: new google.maps.Point(17, 34),
                //    scaledSize: new google.maps.Size(35, 35)
                //}));
                marker.setPosition(place.geometry.location);
                marker.setVisible(true);
            }
        });
    }
    $(document).ready(function () {

    })
    </script>
}

TestRadyaLab/Views/DataRumah/Index.cshtml
@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false&key=AIzaSyBfPWT55ybzPawdPYh58Y85LICkYHQe27U&libraries=places&callback=initMap" async defer></script>
<div class="row">
    <h3>Data Rumah</h3>
    <div class="col-md-6">

    </div>
    <div class="col-md-6 pull-right">
        <div class="pull-right">
            <a class="btn btn-info" href="@Url.Action("Add","DataRumah")">
                <i class="glyphicon glyphicon-plus"></i> Add
            </a>
        </div>
    </div>
</div>
<div class="row" style="margin-top:5px">
    <div class="col-md-5">
        <table id="tblIndex" class="table table-bordered">
            <thead>
                <tr>
                    <td>Action</td>
                    <td>Alamat</td>
                    <td>Type</td>
                    <td>Latitude</td>
                    <td>Longitude</td>
                </tr>
            </thead>
            <tbody>
                @{
                    foreach (TestRadyaLab.Models.Rumah item in (List<TestRadyaLab.Models.Rumah>)ViewBag.listData)
                    {
                <tr>
                    <td>
                        <a href="@Url.Action("Edit", "DataRumah", new { id = item.Id })" class="glyphicon glyphicon-edit"></a>
                        <a href="@Url.Action("Delete", "DataRumah", new { id = item.Id })" class="glyphicon glyphicon-remove"></a>
                    </td>
                    <td>
                        @item.Alamat
                    </td>
                    <td>
                        @item.Tipe
                    </td>
                    <td>
                        @item.Lat
                    </td>
                    <td>
                        @item.Long
                    </td>
                </tr>
                    }
                }
            </tbody>
        </table>
    </div>
    <div class="col-md-7">
        <div id="map" style="width: 100%; height: 500px;"></div>
    </div>
</div>

<div id="ModalMap" class="modal fade" role="dialog">
    <div class="modal-dialog modal-lg">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>
@section scripts{
    <script type="text/javascript">
        var dataProvinsi = [];
        var dataKota = [];
        var dataKecamatan = [];
        var dataLokasi = [];
        var geocoder;
        var map;
        var markers = [];
        @foreach (TestRadyaLab.Models.Rumah item in (List<TestRadyaLab.Models.Rumah>)ViewBag.listData)
        {
            if (item.Provinsi != null && item.Provinsi != "")
            {
                                <text>
        if (jQuery.inArray('@item.Provinsi', dataProvinsi))
            dataProvinsi.push('@item.Provinsi')
        </text>
            }
            if (item.Kota != null && item.Kota != "")
            {
                                <text>
        if (jQuery.inArray('@item.Kota', dataKota))
            dataKota.push('@item.Kota')
        </text>
            }
            if (item.Kecamtan != null && item.Kecamtan != "")
            {
                                <text>
        if (jQuery.inArray('@item.Kecamtan', dataKecamatan))
            dataKecamatan.push('@item.Kecamtan')
        </text>
            }

            <text>
        dataLokasi.push('@item.Alamat')
        </text>
        }

        function initMap() {
            geocoder = new google.maps.Geocoder();
            map = new google.maps.Map(document.getElementById('map'), {
                zoom: 4,
                center: new google.maps.LatLng(-6.9170227, 107.63337000000001),
            });

            var infowindow = new google.maps.InfoWindow();

            map.addListener('zoom_changed', function () {
                for (var i = 0; i < markers.length; i++) {
                    markers[i].setMap(null);
                }
                markers = [];
                if (map.getZoom() >= 14) {
                    $.each(dataLokasi, function (index, value) {
                        geocoder.geocode({ 'address': value }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var marker = new google.maps.Marker(
                                {
                                    map: map,
                                    draggable: false,
                                    position: results[0].geometry.location,
                                    title: value
                                });
                                marker.setVisible(true);
                                markers.push(marker);
                            } else {
                                alert('Geocode was not successful for the following reason: ' + status);
                            }
                        });
                    })
                }
                else if (map.getZoom() >= 10 && map.getZoom() < 14) {
                    $.each(dataKota, function (index, value) {
                        geocoder.geocode({ 'address': value }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var marker = new google.maps.Marker(
                                {
                                    map: map,
                                    draggable: false,
                                    position: results[0].geometry.location,
                                    title: value
                                });
                                marker.setVisible(true);
                                markers.push(marker);
                            } else {
                                alert('Geocode was not successful for the following reason: ' + status);
                            }
                        });
                    })
                }
                else if (map.getZoom() > 0 && map.getZoom() < 10) {
                    $.each(dataProvinsi, function (index, value) {
                        geocoder.geocode({ 'address': value }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var marker = new google.maps.Marker(
                                {
                                    map: map,
                                    draggable: false,
                                    position: results[0].geometry.location,
                                    title: value
                                });
                                marker.setVisible(true);
                                markers.push(marker);
                            } else {
                                alert('Geocode was not successful for the following reason: ' + status);
                            }
                        });
                    })
                }

                
            });
        }

        $(document).ready(function () {
            $('#tblIndex').DataTable({});
        })
    </script>
}

TestRadyaLab/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width" />
    <title>@ViewBag.Title</title>
    
    <link href="~/Content/bootstrap.min.css" rel="stylesheet">
    <link href="~/Content/jquery.dataTables.min.css" rel="stylesheet">
</head>
<body>
    <div class="container-fluid">
        @RenderBody()
    </div>

    <script type="text/javascript" src="~/Scripts/jquery-1.9.1.min.js"></script>
    <script type="text/javascript" src="~/Scripts/bootstrap.min.js"></script>
    <script type="text/javascript" src="~/Scripts/jquery.dataTables.min.js"></script>

    @RenderSection("scripts", required: false)
</body>
</html>